VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "AppTimer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Private iInterval As Long
Private id As Long


Public Item As Variant    ' User can attach any Variant data they want to the timer
Attribute Item.VB_VarDescription = "Gets/sets a piece of additional data to store with the timer."

Public Event Fire()       ' Timer Fire Event

Public Enum enumTimerError
    BaseTimer = 13650     ' AppTimer
    TooManyTimers         ' No more than 10 timers allowed per class
    CantCreateTimer       ' Can't create system timer
End Enum

Friend Sub ErrRaise(ErrNumber As Long)
    Dim sText As String, sSource As String
    
    If ErrNumber > 1000 Then
        
        sSource = App.EXEName & ".WindowProc"
        
        Select Case ErrNumber
        
        Case TooManyTimers: sText = "No more than 10 timers allowed per class"
        Case CantCreateTimer: sText = "Can't create system timer"
        
        End Select
        
        Err.Raise ErrNumber Or vbObjectError, sSource, sText
    
    Else
        
        ' Raise standard Visual Basic error
        Err.Raise ErrNumber, sSource
    
    End If
End Sub


Property Get Interval() As Long
Attribute Interval.VB_Description = "Gets/sets the interval at which the timer fires.  Set to zero to stop the timer."
    
    Interval = iInterval

End Property


Property Let Interval(iIntervalA As Long)
    Dim f As Boolean
    
    If iIntervalA > 0 Then
        
        ' Don't mess with it if interval is the same
        If iInterval = iIntervalA Then Exit Property
        
        ' Must destroy any existing timer to change interval
        If iInterval Then
            
            f = TimerDestroy(Me)
            
            Debug.Assert f      ' Shouldn't fail
        
        End If
        
        ' Create new timer with new interval
        iInterval = iIntervalA
        
        If TimerCreate(Me) = False Then ErrRaise CantCreateTimer
    
    Else
        
        If (iInterval > 0) Then
            
            iInterval = 0
            
            f = TimerDestroy(Me)
            
            Debug.Assert f      ' Shouldn't fail
        
        End If
    
    End If

End Property

Public Sub PulseTimer()
Attribute PulseTimer.VB_MemberFlags = "40"
    RaiseEvent Fire
End Sub

Friend Property Get TimerID() As Long
    
    TimerID = id

End Property

Friend Property Let TimerID(idA As Long)
    
    id = idA

End Property

Private Sub Class_Terminate()
    
    Interval = 0

End Sub

