VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Lib_VBHEngine"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'-----------------------------------------------------------------------------
'-- Highlight Class
'-- Used For Providing Highlighting To A Richtextbox
'-----------------------------------------------------------------------------
'-- Class Name: LibVBHEngine
'-- Created   : 19-07-2002
'-- Author    : Gary Noble
'-- Copyright : Gary Noble 2002
'-----------------------------------------------------------------------------

Implements IHighlight       '-- Highlight Interface

'-- String
    '-- Predefined
    Public TERMINAL_OPENER  As String
    Public TERMINAL_CLOSER  As String
    Public STRING_OPENER    As String
    Public STRING_CLOSER    As String
    Public COMMENT_OPENER   As String
    Public COMMENT_CLOSER   As String
    Public KEYWORD_OPENER   As String
    Public KEYWORD_CLOSER   As String
    Public NUMBER_OPENER    As String
    Public NUMBER_CLOSER    As String
    Public Header           As String
    
'-- Boolean
    '-- Highlight On Return Flag
    Public IsNewLine        As Boolean

'-- Const
    '-- Keywords
    Const mCONST_STR_BLUE_KEYWORDS As String = "*Version*Friend*Begin*Attribute*#Const*#Else*#ElseIf*#End If*#If*Alias*Alias*And*As*Base*Binary*Boolean*Byte*ByVal*Call*Case*CBool*CByte*CCur*CDate*CDbl*CDec*CInt*CLng*Close*Compare*Const*CSng*CStr*Currency*CVar*CVErr*Decimal*Declare*DefBool*DefByte*DefCur*DefDate*DefDbl*DefDec*DefInt*DefLng*DefObj*DefSng*DefStr*DefVar*Dim*Do*Double*Each*Else*ElseIf*End*Enum*Eqv*Erase*Error*Exit*Explicit*False*For*Function*Get*Global*GoSub*GoTo*If*Imp*In*Input*Input*Integer*Is*LBound*Let*Lib*Like*Line*Lock*Long*Loop*LSet*Name*New*Next*Not*Object*On*Open*Option*Or*Output*Print*Private*Property*Public*Put*Random*Read*ReDim*Resume*Return*RSet*Seek*Select*Set*Single*Spc*Static*String*Stop*Sub*Tab*Then*Then*True*Type*UBound*Unlock*Variant*Wend*While*With*Xor*Nothing*To*"
    Const mCONST_STR_TERMINAL_CHARACTERS As String = "*-*0*1*2*3*4*5*6*7*8*9*\*\\*.*(*)*=* *,*-*+*/**\*%*'*"

'-----------------------------------------------------------------------------
'-- Function:    ColourText
'-- Description: Set ball In Motion
'--
'-- Assumes:     IHighlight_ProcessHighlight
'-- Inputs:      sInput (String To Colour)
'-- Created:     Gary Noble (19-07-2002
'-----------------------------------------------------------------------------
Public Function ColourText(sInput As String) As String
    
    KEYWORD_OPENER = KEYWORD_OPENER & "\cf1"
    KEYWORD_CLOSER = KEYWORD_CLOSER & "\cf4"
    
    sInput = Replace(sInput, vbTab, "\tab")
    
    If Right(sInput, 1) <> " " Then
        sInput = sInput & " "  '  Left(sInput, Len(sInput) - 1)
    End If
    
    
    ColourText = IHighlight_ProcessHighlight(sInput)

End Function
'-----------------------------------------------------------------------------
'-- Function:    FormatVBWord
'-- Description: Retturns The Word If Its Park Of The KeyWord List
'--
'-- Assumes:     KeyWords
'-- Inputs:      sInput (String To Colour)
'-- Created:     Gary Noble (19-07-2002
'-----------------------------------------------------------------------------
Private Function IHighlight_FormatVBWord(ByVal sInput As String) As Variant
        
        If InStr(1, StrConv(mCONST_STR_BLUE_KEYWORDS, vbLowerCase), "*" & StrConv(sInput, vbLowerCase) & "*") Then
           IHighlight_FormatVBWord = KEYWORD_OPENER & StrConv(sInput, vbProperCase) & STRING_CLOSER  ' KEYWORD_CLOSER
          
        Else
            IHighlight_FormatVBWord = sInput
        End If
            
End Function

'-----------------------------------------------------------------------------
'-- Function:    IsTerminalChar
'-- Description: Returns The Terminal Character
'--
'-- Assumes:     Nothing
'-- Inputs:      sChar (Terminal Char To Analyze)
'-- Created:     Gary Noble (19-07-2002
'-----------------------------------------------------------------------------
Private Function IHighlight_IsTerminalChar(ByVal sChar As Variant) As Boolean

        Select Case sChar
            Case " ": IHighlight_IsTerminalChar = True: Exit Function
            Case """": IHighlight_IsTerminalChar = True: Exit Function
            Case "{": IHighlight_IsTerminalChar = True: Exit Function
            Case "}": IHighlight_IsTerminalChar = True: Exit Function
            Case vbTab: IHighlight_IsTerminalChar = True: Exit Function
            Case ",": IHighlight_IsTerminalChar = True: Exit Function
            Case vbCr: IHighlight_IsTerminalChar = True: Exit Function
            Case vbLf: IHighlight_IsTerminalChar = True: Exit Function
            Case vbCrLf: IHighlight_IsTerminalChar = True: Exit Function
        End Select
        
        If InStr(1, StrConv(mCONST_STR_TERMINAL_CHARACTERS, vbLowerCase), "*" & sChar & "*") Then
            IHighlight_IsTerminalChar = True
        Else
            IHighlight_IsTerminalChar = False
        End If

End Function


'-----------------------------------------------------------------------------
'-- Function:    ProcessHighlight
'-- Description: Does The Actual Colouring Of The Text
'--
'-- Assumes:     objAppend (String Contat)
'-- Inputs:      sInput (String To Colour)
'-- Created:     Gary Noble (19-07-2002)
'-----------------------------------------------------------------------------
Private Function IHighlight_ProcessHighlight(sInput As String) As Variant
    
    Dim objAppend       As New Lib_AppendString     '-- String Contat
    
    'Dim sOutput         As String
    Dim sTemp           As String                   '-- String Buffering
    Dim sChar           As String                   '-- String Buffering
    
    Dim lCount          As Long                     '-- Counter
    Dim lMax            As Long                     '-- Max Length
    
    Dim bInString       As Boolean                  '-- String Flag
    Dim bInComment      As Boolean                  '-- Comment Flag
      
    If Left(sInput, 1) <> " " Then
        sInput = sInput & " "
    End If
    
      
    '-- Set Defaults
    lMax = Len(sInput)
   
    bInString = False
    bInComment = False
    
        objAppend.BufferPages = 99999
        objAppend.BufferPageSize = 4096
        
        '-- Start Colouring
        For lCount = 1 To lMax
            
            '-- Retrieve The Char We Want To Process
            sChar = Mid$(sInput, lCount, 1)
            
            If (Left(sInput, 1) = " " And lCount = 1) Then
                sInput = Mid(sInput, 1, Len(sInput))
            End If
            
            
            
            If IHighlight_IsTerminalChar(sChar) Then
                
                '-- Close A String
              
                    
               If sChar = Chr(34) And bInString And Not bInComment Then
                    objAppend.Append STRING_OPENER & "\cf0" & sTemp & """" & STRING_CLOSER '& "\cf0"    '& Replace(sTemp & sChar, " ", " ")
                    bInString = False
                    sTemp = " "
               
               ElseIf sChar = " " And bInString And Not bInComment Then
             
                    objAppend.Append STRING_OPENER & "\cf0" & sTemp & " " & STRING_CLOSER '"\cf0"    '& Replace(sTemp & sChar, " ", " ")
                    bInString = True
                    sTemp = " "
                
                '-- Open A String
                ElseIf sChar = Chr(34) And Not (bInString Or bInComment) Then
                    bInString = True
                    objAppend.Append IHighlight_FormatVBWord(sTemp) & "\cf4"
                    sTemp = sChar
                
                '-- Comment Text
                ElseIf Not (bInString Or bInComment) And sChar = "'" Or sChar = "' " Then
                    bInComment = True
                    objAppend.Append IHighlight_FormatVBWord(sTemp) & "\cf4"
                    sTemp = "'"
                
                '-- End Of Line
                ElseIf bInComment And sChar = vbCr Or sChar = "" Then
                    objAppend.Append COMMENT_OPENER & sTemp & COMMENT_CLOSER & "\cf4\par"
                    sTemp = ""
                    bInComment = False
                
                ElseIf bInComment And sChar = " " Then
                    objAppend.Append COMMENT_OPENER & sTemp & COMMENT_CLOSER & "\cf4"
                    sTemp = " "
                    bInComment = True
                
                '-- Terminal Text
                ElseIf Not (bInString Or bInComment) Then
                                                        
                    
                    
                    If IsNumeric(sChar) Then
                        '==> NUMBER_OPENER & sTemp &
                        objAppend.Append NUMBER_OPENER & sChar & NUMBER_CLOSER  'Replace(sChar, vbCr, "\par")
                    Else
                        If sChar = "\" Then     '-- Richtext Doesnot Support Single '\' Characters
                            sChar = "\\"        '-- We Must Place A Extra '\' For It To Show
                            objAppend.Append IHighlight_FormatVBWord(sTemp) & TERMINAL_OPENER & sChar & TERMINAL_CLOSER   ' Replace(sChar, vbCr, "\par")
                        Else
                            If lCount = 1 And sChar = " " Then
                            sChar = ""
                                objAppend.Append sTemp & TERMINAL_OPENER & Replace(sChar, vbCr, "\par") & TERMINAL_CLOSER
                            Else
                                objAppend.Append IHighlight_FormatVBWord(sTemp) & TERMINAL_OPENER & Replace(sChar, vbCr, "\par") & TERMINAL_CLOSER
                            End If
                        End If
                   End If
                   
Skipit:
                   
                    sTemp = ""
                Else
                    sTemp = sTemp '& Replace(sChar, " ", " ")
                End If '-- sChar = Chr(34) And bInString And Not bInComment Then

            Else
                
'                MsgBox lCount & vbCrLf & sChar
                
                
                If (lCount = 1 And sChar = Chr(32)) Then  'lCount = lMax And sChar = " " Or
                    sTemp = sTemp & sChar
                    MsgBox "KSDJFLKS"
                End If
                
                If (lCount = lMax And sChar = " ") Then 'lCount = lMax And sChar = " " Or
                    sTemp = sTemp & sChar
                    MsgBox "KSDJFLKS"
                Else
                    sTemp = sTemp & sChar
                End If
            End If '-- IHighlight_IsTerminalChar(sChar) Then
        
Skip:
        
        Next
        
        '-- Return The Highlighted Text
        IHighlight_ProcessHighlight = objAppend.Value & "\cf0" & sTemp & "\cf4"
            
        
        objAppend.Flush
        objAppend.ReleaseMemory
              

        Set objAppend = Nothing


End Function


